import { ComponentType, FunctionComponent } from 'react';
export declare type Dakpan<S, A extends Actions<S>> = [FunctionComponent, DakpanHook<S, A>, DakpanHoc<S, A>];
export declare type DakpanHook<S, A extends Actions<S>> = () => [S, MappedActions<S, A>];
export declare type DakpanHoc<S, A extends Actions<S>> = <H>(map: (state: S, actions: MappedActions<S, A>) => H) => <P>(component: ComponentType<P & H>) => ComponentType<P>;
export declare type ProviderCallback<S> = (get?: GetState<S>, set?: SetState<S>) => void;
export declare type GetState<S> = () => S;
export declare type SetState<S> = (value: S) => void;
export declare type Actions<S> = {
    [action: string]: (...args: any[]) => (state: S) => S | undefined | Promise<S | undefined>;
};
export declare type MappedActions<S, A extends Actions<S>> = {
    [K in keyof A]: ((...args: Parameters<A[K]>) => Promise<void>) & {
        c: (...args: Parameters<A[K]>) => () => Promise<void>;
    };
};
export declare type InitialState<S> = S | (() => S);
//# sourceMappingURL=types.d.ts.map